define("io.ox/mail/write/test",["io.ox/mail/write/main","io.ox/mail/api","io.ox/mail/util","io.ox/core/api/account","io.ox/core/extensions","io.ox/mail/sender","io.ox/mail/write/test/html_send","io.ox/mail/write/test/text_send","io.ox/mail/write/test/html_reply"],function(a,b,c,d,e,f){var g=ox.base+"/apps/io.ox/mail/write/test",h=ox.testTimeout;"use strict";function i(){var a=function(){return a.value};a.value=!1;a.yep=function(){a.value=!0};return a}function j(a){return $.trim((a+"").replace(/[\r\n]+/g
,""))}e.point("test/suite").extend({id:"mail-compose",index:100,test:function(c){c.describe("Compose email",function(){var e,f,g=null,j=null,k=null;c.it("opens compose dialog in HTML mode",function(){var b=new i;c.waitsFor(b,"compose dialog",h);a.getApp().launch().done(function(){g=this;g.compose().done(function(){g.setFormat("html").done(function(){j=g.getEditor();k=g.getWindow().nodes.main.find("form");b.yep();c.expect(j).toBeDefined();c.expect(k).toBeDefined();c.expect(j.getMode()).toEqual("html"
)})})})});c.it("adds recipient",function(){var a;k.find("input[data-type=to]").val("otto.xentner@io.ox").focus().trigger($.Event("keyup",{which:13}));a=k.find(".recipient-list input[type=hidden][name=to]");c.expect(a.val()).toEqual('"otto.xentner" <otto.xentner@io.ox>')});c.it("adds recipient with display name",function(){var a;k.find("input[data-type=to]").val('"Otto X." <otto.xentner@io.ox>').focus().trigger($.Event("keyup",{which:13}));a=k.find(".recipient-list input[type=hidden][name=to]").last
();c.expect(a.val()).toEqual('"Otto X." <otto.xentner@io.ox>')});c.it("adds recipient by focussing another element",function(){var a;k.find("input[data-type=to]").val('"Otto;must escape,this" <otto.xentner@io.ox>').focus().blur();a=k.find(".recipient-list input[type=hidden][name=to]").last();c.expect(a.val()).toEqual('"Otto;must escape,this" <otto.xentner@io.ox>')});c.it("adds multiple recipients at once",function(){var a;k.find("input[data-type=to]").val(' "Otto;must escape,this" <otto.xentner@io.ox>; "Hannes" <hannes@ox.io>, Horst <horst@ox.io>;, '
).focus().blur();a=k.find(".recipient-list input[type=hidden][name=to]").slice(-3);c.expect(!0).toEqual(a.eq(0).val()==='"Otto;must escape,this" <otto.xentner@io.ox>'&&a.eq(1).val()==='"Hannes" <hannes@ox.io>'&&a.eq(2).val()==='"Horst" <horst@ox.io>')});c.it("opens CC section",function(){var a;k.find("[data-section-link=cc]").trigger("click");a=k.find("[data-section=cc]:visible");c.expect(a.length).toEqual(1)});c.it("adds recipient to CC",function(){var a;k.find("input[data-type=cc]").val("otto.xentner@io.ox"
).focus().trigger($.Event("keyup",{which:13}));a=k.find(".recipient-list input[type=hidden][name=cc]");c.expect(a.val()).toEqual('"otto.xentner" <otto.xentner@io.ox>')});c.it("opens BCC section",function(){var a;k.find("[data-section-link=bcc]").trigger("click");a=k.find("[data-section=bcc]:visible");c.expect(a.length).toEqual(1)});c.it("adds recipient to BCC",function(){var a;k.find("input[data-type=bcc]").val("hannes@io.ox").focus().trigger($.Event("keyup",{which:13}));a=k.find(".recipient-list input[type=hidden][name=bcc]"
);c.expect(a.val()).toEqual('"hannes" <hannes@io.ox>')});c.it("removes recipient from BCC",function(){var a,b=k.find(".recipient-list input[type=hidden][name=bcc]");b.parent().find("a.remove").trigger("click");a=k.find(".recipient-list input[type=hidden][name=bcc]");c.expect(!0).toEqual(b.length===1&&a.length===0)});c.it("closes BCC section",function(){var a;k.find("[data-section-label=bcc]").trigger("click");a=k.find("[data-section=bcc]:visible");c.expect(a.length).toEqual(0)});c.it("sets high priority"
,function(){var a;k.find("input[name=priority]").eq(0).focus().prop("checked",!0).trigger("change").blur();a=k.find(".priority-overlay");c.expect(a.hasClass("high")).toEqual(!0)});c.it("sets subject",function(){k.find("input.subject").val("TEST: Hello World");c.expect(k.find("input[name=subject]").val()).toEqual("TEST: Hello World")});c.it("sets editor content",function(){j.setContent(" <p>Lorem ipsum</p>\r\n ");c.expect(j.getContent()).toEqual("<p>Lorem ipsum</p>")});c.it("has correct mail body"
,function(){var a=g.getMail().data;c.expect(a.attachments&&a.attachments.length&&a.attachments[0].content_type==="text/html").toEqual(!0);c.expect(a.attachments[0].content).toEqual("<p>Lorem ipsum</p>")});c.it("has correct mail props (bcc)",function(){var a=g.getMail().data;c.expect(_.isArray(a.bcc)&&a.bcc.length===0).toEqual(!0)});c.it("has correct mail props (cc)",function(){var a=g.getMail().data;c.expect(_.isArray(a.cc)&&a.cc.length===1&&a.cc[0][0]==='"otto.xentner"'&&a.cc[0][1]==="otto.xentner@io.ox"
).toEqual(!0)});c.it("has correct mail props (from)",function(){var a=g.getMail().data;c.expect(_.isArray(a.from)&&a.from.length===1).toEqual(!0)});c.it("has correct mail props (priority)",function(){var a=g.getMail().data;c.expect(a.priority===1).toEqual(!0)});c.it("has correct mail props (subject)",function(){var a=g.getMail().data;c.expect(a.subject==="TEST: Hello World").toEqual(!0)});c.it("has correct mail props (to)",function(){var a=g.getMail().data;c.expect(_.isArray(a.to)&&a.to.length===6&&
a.to[4][0]==='"Hannes"'&&a.to[4][1]==="hannes@ox.io").toEqual(!0)});c.it("has correct mail props (vcard)",function(){var a=g.getMail().data;c.expect(a.vcard===0).toEqual(!0)});e={};if(!_.browser.IE){c.it("sends mail successfully",function(){var a=g.getMail().data,j=new i;c.waitsFor(j,"mail being send",h);d.getPrimaryAddress().done(function(d){a.to=[d];a.cc=[];a.bcc=[];f=a;b.send(a).always(function(a){j.yep();e=String(a.data);c.expect(a.error).toBeUndefined()})})});c.it("verifies that sent mail is ok"
,function(){var a=new i,d=f,g=e.split(/\/(\d+$)/);c.waitsFor(a,"mail being fetched",h);b.get({folder:g[0],id:g[1]}).done(function(b){a.yep();c.expect(_.isEqual(b.subject,d.subject)&&_.isEqual(b.from,d.from)&&_.isEqual(b.to,d.to)&&_.isEqual(b.cc,d.cc)&&_.isEqual(b.bcc,d.bcc)&&_.isEqual(b.priority,d.priority)&&_.isEqual(b.vcard||undefined,d.vcard||undefined)).toEqual(!0)})})}c.it("closes compose dialog",function(){g.dirty(!1).quit();c.expect(g.getEditor).toBeUndefined();g=j=k=null})})}});e.point("test/suite"
).extend({id:"mail-editor",index:200,test:function(b){b.describe("Mail editor",function(){var c=null,d=null;b.it("opens compose dialog in TEXT mode",function(){var e=new i;b.waitsFor(e,"compose dialog",h);a.getApp().launch().done(function(){c=this;c.compose().done(function(){c.setFormat("text").done(function(){d=c.getEditor();e.yep();b.expect(d).toBeDefined();b.expect(d.getMode()).toEqual("text")})})})});b.it("sets TEXT content",function(){d.setContent("  Hallo Welt\nLine #1\nLine #3\n\nNext paragraph\n\n"
);b.expect(d.getContent()).toEqual("Hallo Welt\nLine #1\nLine #3\n\nNext paragraph")});b.it("appends TEXT content",function(){d.appendContent("---\nCould be a signature");b.expect(d.getContent()).toEqual("Hallo Welt\nLine #1\nLine #3\n\nNext paragraph\n\n---\nCould be a signature")});b.it("removes TEXT",function(){d.replaceParagraph("---\nCould be a signature","");b.expect(d.getContent()).toEqual("Hallo Welt\nLine #1\nLine #3\n\nNext paragraph")});b.it("clears all content",function(){d.clear();b.
expect(d.getContent()).toEqual("")});b.it("scrolls to bottom",function(){d.setContent((new Array(500)).join("All work and no play makes Bart a dull boy\n"));d.scrollTop("bottom");b.expect(d.scrollTop()).toBeGreaterThan(0)});b.it("scrolls back to top",function(){d.scrollTop("top");b.expect(d.scrollTop()).toEqual(0)});b.it("replaces TEXT properly",function(){d.setContent("All work and no play makes Bart a dull boy");d.replaceParagraph("Bart","me");b.expect(d.getContent()).toEqual("All work and no play makes me a dull boy"
)});b.it("changes editor mode to HTML",function(){var a=new i;b.waitsFor(a,"HTML mode",h);c.setFormat("html").done(function(){d=c.getEditor();a.yep();b.expect(d.getContent()).toEqual("<p>All work and no play makes me a dull boy</p>")})});b.it("sets HTML content",function(){d.setContent("<p>Hello World<br>Line #2</p><p></p><p><br><p>");b.expect(d.getContent()).toEqual("<p>Hello World<br>Line #2</p>")});b.it("appends TEXT content in HTML mode properly",function(){d.appendContent("Yeah\nI am just plain text"
);b.expect(d.getContent()).toEqual("<p>Hello World<br>Line #2</p><p>Yeah<br>I am just plain text</p>")});b.it("removes a specific paragraph",function(){d.replaceParagraph("<p>Yeah<br>I am just plain text</p>","");b.expect(d.getContent()).toEqual("<p>Hello World<br>Line #2</p>")});b.it("appends HTML content in HTML mode properly",function(){d.appendContent("<p>Yeah<br>I am just plain text</p><p></p>");b.expect(d.getContent()).toEqual("<p>Hello World<br>Line #2</p><p>Yeah<br>I am just plain text</p>"
)});b.it("clears all content",function(){d.clear();b.expect(d.getContent()).toEqual("")});b.it("scrolls to bottom",function(){d.setContent((new Array(500)).join("All work and no play makes Bart a dull boy<br>"));d.scrollTop("bottom");b.expect(d.scrollTop()).toBeGreaterThan(0)});b.it("scrolls back to top",function(){d.scrollTop("top");b.expect(d.scrollTop()).toEqual(0)});b.it("replaces a specific paragraph",function(){d.setContent("<p>All work and no play makes me a dull boy</p>");d.replaceParagraph
("<p>All work and no play makes me a dull boy</p>","<p>YEAH</p>");b.expect(d.getContent()).toEqual("<p>YEAH</p>")});b.it("switches back to TEXT mode",function(){var a;d.setContent("<p><b>Paragraph &lt;#1&gt;</b><br>Line #2</p><h1>Headline</h1><p>Paragraph #2</p>");a=new i;b.waitsFor(a,"TEXT mode",h);c.setFormat("text").done(function(){d=c.getEditor();a.yep();b.expect(d.getMode()).toEqual("text");b.expect(d.getContent()).toEqual("Paragraph <#1>\nLine #2\n\nHeadline\n\nParagraph #2")})});b.it("switches back to HTML mode"
,function(){var a=new i;b.waitsFor(a,"HTML mode",h);c.setFormat("html").done(function(){d=c.getEditor();a.yep();b.expect(d.getContent()).toEqual("<p>Paragraph &lt;#1&gt;<br>Line #2</p><p>Headline</p><p>Paragraph #2</p>")})});b.it("switches back and forth between TEXT and HTML mode (robustness test)",function(){var a,e;c.setFormat("text");c.setFormat("html");c.setFormat("html");c.setFormat("text");c.setFormat("text");c.setFormat("html");a=new i;b.waitsFor(a,"checkpoint #1",h);c.setFormat("text").done
(function(){d=c.getEditor();a.yep();b.expect(d.getContent()).toEqual("Paragraph <#1>\nLine #2\n\nHeadline\n\nParagraph #2")});e=new i;b.waitsFor(e,"checkpoint #2",h);c.setFormat("html").done(function(){d=c.getEditor();e.yep();b.expect(d.getContent()).toEqual("<p>Paragraph &lt;#1&gt;<br>Line #2</p><p>Headline</p><p>Paragraph #2</p>")})});b.it("closes compose dialog",function(){c.dirty(!1).quit();b.expect(c.getEditor).toBeUndefined();c=d=null})})}});e.point("test/suite").extend({id:"mail-paste",index
:300,test:function(b){b.describe("Paste HTML contents",function(){var c=null,d=null;b.it("opens compose dialog",function(){var e=new i;b.waitsFor(e,"compose dialog",h);a.getApp().launch().done(function(){c=this;c.compose().done(function(){c.setFormat("html").done(function(){d=c.getEditor();e.yep();b.expect(d).toBeDefined();b.expect(d.getMode()).toEqual("html")})})})});b.it("inserts simple example",function(){b.runs(function(){d.clear();d.paste("<p>Hello World</p>");b.expect(d.getContent()).toEqual
("<p>Hello World</p>")})});b.it("removes text color",function(){b.runs(function(){d.clear();d.paste('<p style="color: red">Hello World</p>');b.expect(d.getContent()).toEqual("<p>Hello World</p>")})});b.it("does not mess up paragraphs and line-breaks",function(){d.clear();d.paste("<p>Hello<br />World</p><p>one empty line, then this one</p>");b.expect(d.getContent()).toEqual("<p>Hello<br>World</p><p>one empty line, then this one</p>")});b.it("handles complex HTML right #1",function(){var a=new i;b.
waitsFor(a,"external test data",h);$.when($.get(g+"/test_1a.html"),$.get(g+"/test_1b.html")).done(function(c,e){a.yep();d.clear();d.paste(c[0]);b.expect(d.getContent()).toEqual(j(e[0]))})});b.it("handles complex HTML right #2",function(){var a=new i;b.waitsFor(a,"external test data",h);$.when($.get(g+"/test_2a.html"),$.get(g+"/test_2b.html")).done(function(c,e){a.yep();d.clear();d.paste(c[0]);b.expect(d.getContent()).toEqual(j(e[0]))})});b.it("closes compose dialog",function(){c.dirty(!1).quit();
b.expect(c.getEditor).toBeUndefined();c=d=null})})}});e.point("test/suite").extend({id:"mail-account",index:400,test:function(a,b){a.describe("Mail Account API",function(){var c=d,e={addresses:"matthias.biggeleben@OX.IO",confirmed_ham:"confirmed-ham",confirmed_ham_fullname:"default0/INBOX/confirmed-ham",confirmed_spam:"confirmed-spam",confirmed_spam_fullname:"default0/INBOX/confirmed-spam",drafts:"Entwürfe",drafts_fullname:"default0/INBOX/Entwürfe",id:0,login:"matthias.biggeleben",mail_port:143,mail_protocol
:"imap",mail_secure:!1,mail_server:"ox.open-xchange.com",mail_url:"imap://ox.open-xchange.com:143",meta:null,name:"Email",password:null,personal:"Biggeleben",pop3_delete_write_through:!1,pop3_expunge_on_quit:!1,pop3_path:"INBOX/EMail",pop3_refresh_rate:null,pop3_storage:null,primary_address:"matthias.biggeleben@OX.IO",reply_to:null,sent:"Gesendete Objekte",sent_fullname:"default0/INBOX/Gesendete Objekte",spam:"Spam",spam_fullname:"default0/INBOX/Spam",spam_handler:"NoSpamHandler",transport_login:"matthias.biggeleben"
,transport_password:null,transport_port:25,transport_protocol:"smtp",transport_secure:!1,transport_server:"ox.open-xchange.com",transport_url:"smtp://ox.open-xchange.com:25",trash:"Papierkorb",trash_fullname:"default0/INBOX/Papierkorb",unified_inbox_enabled:!1};a.it("sets custom account data",function(){var b=new i;a.waitsFor(b,"set data",h);c.cache.clear().done(function(){c.cache.keys().done(function(d){a.expect(d.length).toEqual(0);$.when(c.cache.add(e)).done(function(){c.all().done(function(c)
{b.yep();a.expect(c.length).toEqual(1)})})})})});a.it("returns proper account data",function(){var b=new i;a.waitsFor(b,"load account",h);c.get(0).done(function(c){a.expect(c.id).toEqual(0);a.expect(c.login).toEqual("matthias.biggeleben");b.yep()})});a.it("is account",function(){a.expect(c.isAccount(0)).toEqual(!0);a.expect(c.isAccount(1)).toEqual(!1)});a.it("is primary account",function(){a.expect(c.isPrimary("default0/yeah")).toEqual(!0);a.expect(c.isPrimary("default1/nope")).toEqual(!1)});a.it
('is "inbox" folder',function(){a.expect(c.is("inbox","default0/INBOX")).toEqual(!0);a.expect(c.is("inbox","default0/XOBNI")).toEqual(!1)});a.it('is "sent" folder',function(){a.expect(c.is("sent","default0/INBOX/Gesendete Objekte")).toEqual(!0);a.expect(c.is("sent","default0/INBOX/nope")).toEqual(!1)});a.it("parses account id",function(){var b=c.parseAccountId("default0");a.expect(b).toEqual(0);b=c.parseAccountId("default01337",!0);a.expect(b).toEqual(1337);b=c.parseAccountId(0);a.expect(b).toEqual
(0)});a.it("returns correct primary address",function(){var b=new i;a.waitsFor(b,"get primary address",h);require(["settings!io.ox/mail"]).then(function(d){d.detach().set("defaultSendAddress"," matthias.biggeleben@ox.io ");c.getPrimaryAddress(0).done(function(c){a.expect(c).toEqual(["Biggeleben","matthias.biggeleben@ox.io"]);b.yep()})})});a.it("uses default display_name as fallback (personal)",function(){var b=new i;a.waitsFor(b,"default display_name",h);e.personal="";$.when(c.getDefaultDisplayName
(),c.cache.add(e)).done(function(d){c.getPrimaryAddress(0).done(function(c){a.expect(c).toEqual([d,"matthias.biggeleben@ox.io"]);b.yep()})})});a.it("returns correct sender addresses",function(){var b=new i;a.waitsFor(b,"sender addresses",h);e.addresses=" ALL@open-xchange.com, matthias.biggeleben@ox.io,mattes@open-xchange.com ";c.cache.add(e).done(function(){c.getSenderAddresses(0).done(function(c){var d=[["Matthias Biggeleben","all@open-xchange.com"],["Matthias Biggeleben","matthias.biggeleben@ox.io"
],["Matthias Biggeleben","mattes@open-xchange.com"]];a.expect(c).toEqual(d);b.yep()})})});a.it("returns all sender addresses across all accounts",function(){var b,d=new i;a.waitsFor(d,"all sender addresses",h);b=_.extend(e,{addresses:" test@gmail.com,   FOO@gmail.com, yeah@gmail.com",id:1,personal:"Test",primary_address:"FOO@gmail.com"});c.cache.add(b).done(function(){c.getAllSenderAddresses().done(function(b){var c=[["Matthias Biggeleben","all@open-xchange.com"],["Matthias Biggeleben","matthias.biggeleben@ox.io"
],["Matthias Biggeleben","mattes@open-xchange.com"],["Test","foo@gmail.com"],["Test","test@gmail.com"],["Test","yeah@gmail.com"]];a.expect(b).toEqual(c);d.yep()})})});a.it("returns correct primary address for folder_id",function(){var b=new i;a.waitsFor(b,"get address",h);c.getPrimaryAddressFromFolder("default1/INBOX/test").done(function(c){a.expect(c).toEqual(["Test","foo@gmail.com"]);b.yep()})});a.it("returns correct primary address for account_id",function(){var b=new i;a.waitsFor(b,"get address"
,h);c.getPrimaryAddressFromFolder(1).done(function(c){a.expect(c).toEqual(["Test","foo@gmail.com"]);b.yep()})});a.it("creates proper select-box with sender addresses",function(){var c,d=new i;a.waitsFor(d,"get addresses",h);b.node.append(c=$('<select class="sender-dropdown" size="1">').css("width","400px"));f.getNumbers=function(){return $.Deferred().resolve({cellular_telephone0:"+49 151 00 000 001",cellular_telephone1:"+49 151 99 888 777",cellular_telephone2:"+49 151 99 999 888",cellular_telephone3
:" "})};f.getMapping=function(){return["cellular_telephone1","cellular_telephone2","cellular_telephone3"]};f.drawOptions(c).done(function(){a.expect(c.children().length).toEqual(8);a.expect(c.find("[default]").length).toEqual(1);d.yep()})});function g(a){var c=b.node.find(".sender-dropdown");f.set(c,a)}function j(){var a=b.node.find(".sender-dropdown");return f.get(a)}a.it("sets initial value of select-box correctly",function(){var b=j();a.expect(b).toEqual(["Matthias Biggeleben","matthias.biggeleben@ox.io"
])});a.it("sets value of select-box correctly",function(){var c;g(["Test","foo@gmail.com"]);c=b.node.find(".sender-dropdown").prop("selectedIndex");a.expect(c).toEqual(5)});a.it("uses default address if invalid values are set",function(){var c,d,e;g(["Test","not-in@the.list"]);c=b.node.find(".sender-dropdown"),d=c.prop("selectedIndex"),e=c.val();a.expect(d).toEqual(4);a.expect(e).toEqual('"Matthias Biggeleben" <matthias.biggeleben@ox.io>')});a.it("selects proper address during initial loading",function(
){var c,d=new i;a.waitsFor(d,"async test",h);c=b.node.find(".sender-dropdown");c.empty().removeAttr("data-default");g(["Test","foo@gmail.com"]);a.expect(c.val()).toEqual(null);a.expect(c.children().length).toEqual(0);setTimeout(function(){f.drawOptions(c).done(function(){var c=b.node.find(".sender-dropdown").prop("selectedIndex");a.expect(c).toEqual(5);d.yep()})},100)});a.it("resets account data",function(){var b=new i;a.waitsFor(b,"reset data",h);c.cache.clear().done(function(){c.all().done(function(
c){a.expect(c.length>=1).toEqual(!0);b.yep()})})})})}})});